
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	OR	257
#define	AND	258
#define	REL_EQ	259
#define	REL_NE	260
#define	REL_LE	261
#define	REL_GE	262
#define	LEFT	263
#define	RIGHT	264
#define	UMINUS	265
#define	INDIRECT	266
#define	INCDEC	267
#define	ABS	268
#define	SIGN	269
#define	TYPE	270
#define	EVENT_SRC	271
#define	LOWER_THAN_ELSE	272
#define	ELSE	273
#define	LOWER_THAN_EXPR_SHIFT	274
#define	ID	275
#define	NUMBER	276
#define	ASSIGN	277
#define	ASSIGN2	278
#define	TASKOP	279
#define	JUMP	280
#define	TASK	281
#define	SUB	282
#define	STRING	283
#define	PP_DEFINE	284
#define	PP_INCLUDE	285
#define	NL	286
#define	WS	287
#define	PP_ARG	288
#define	PP_UNKNOWN	289
#define	PP_IFDEF	290
#define	PP_IF	291
#define	PP_ELSE	292
#define	PP_ELIF	293
#define	PP_ENDIF	294
#define	PP_UNDEF	295
#define	PP_PRAGMA	296
#define	PP_GLOM	297
#define	PP_ERROR	298
#define	PP_WARNING	299
#define	IF	300
#define	WHILE	301
#define	DO	302
#define	FOR	303
#define	REPEAT	304
#define	SWITCH	305
#define	CASE	306
#define	DEFAULT	307
#define	MONITOR	308
#define	CATCH	309
#define	ACQUIRE	310
#define	GOTO	311
#define	ASM	312
#define	INT	313
#define	T_VOID	314
#define	T_CONST	315
#define	SENSOR	316
#define	TASKID	317
#define	NOLIST	318
#define	CTRUE	319
#define	CFALSE	320

#line 1 "parse.y"

/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of this code is David Baum.
 * Portions created by David Baum are Copyright (C) 1998 David Baum.
 * All Rights Reserved.
 */
#line 19 "parse.y"

// prevent redefinition of YYSTYPE in parser.h
#define __PARSE_TAB_H

// these classes must be defined prior to YYSTYPE
#include "Fragment.h"
#include "BlockStmt.h"
#include "Symbol.h"
#include "Expr.h"
#include "FunctionDef.h"
#include "CallStmt.h"
#include "AsmStmt.h"
#include "CaseStmt.h"
#include "DeclareStmt.h"
#include "Fragment.h"

class Clause;
class LocationNode;


#line 40 "parse.y"
typedef union {
	int			fInt;
	bool		fBool;
	Fragment*	fFragment;
	Stmt*		fStmt;
	BlockStmt*	fBlock;
	Symbol*		fSymbol;
	char*		fString;
	Expr*		fExpr;
	FunctionDef*	fFunction;
	CallStmt*	fCall;
	AsmStmt*	fAsmStmt;
	Field*		fField;
	CaseStmt*	fCaseStmt;
	DeclareStmt*	fDeclareStmt;
	LocationNode*	fLocation;
} YYSTYPE;
#line 59 "parse.y"

#include <stdlib.h>
#include "IfStmt.h"
#include "WhileStmt.h"
#include "AsmStmt.h"
#include "DoStmt.h"
#include "RepeatStmt.h"
#include "AssignStmt.h"
#include "TaskStmt.h"
#include "JumpStmt.h"
#include "SwitchStmt.h"
#include "ExprStmt.h"
#include "RCX_Constants.h"
#include "PreProc.h"
#include "parser.h"
#include "Program.h"
#include "parse_util.h"
#include "Program.h"
#include "IncDecExpr.h"
#include "AtomExpr.h"
#include "TypeExpr.h"
#include "Error.h"
#include "MonitorStmt.h"
#include "EventSrcExpr.h"
#include "SensorExpr.h"
#include "AssignMathStmt.h"
#include "ForStmt.h"
#include "RelExpr.h"
#include "NegateExpr.h"
#include "LogicalExpr.h"
#include "TernaryExpr.h"
#include "LabelStmt.h"
#include "GotoStmt.h"

#define yylex()		(gPreProc->Get(yylval))

static LexLocation sSavedLoc;

#line 147 "parse.y"

static void yyerror(const char *msg);

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		290
#define	YYFLAG		-32768
#define	YYNTBASE	91

#define YYTRANSLATE(x) ((unsigned)(x) <= 320 ? yytranslate[x] : 124)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    26,     2,     2,     2,    22,     9,     2,    85,
    35,    20,    19,    86,    18,     2,    21,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     3,    82,    12,
    87,    13,     4,    90,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    88,     2,    89,     8,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    83,     7,    84,    24,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     5,     6,    10,    11,
    14,    15,    16,    17,    23,    25,    27,    28,    29,    30,
    31,    32,    33,    34,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,    10,    14,    21,    28,    30,    31,
    37,    43,    45,    47,    48,    53,    56,    58,    61,    64,
    68,    70,    74,    76,    78,    82,    85,    91,    92,    97,
   100,   101,   103,   105,   108,   113,   116,   118,   121,   128,
   137,   144,   151,   158,   167,   176,   185,   196,   201,   207,
   211,   216,   223,   227,   230,   232,   236,   240,   244,   246,
   247,   249,   250,   252,   253,   256,   257,   260,   267,   270,
   275,   279,   281,   282,   286,   288,   291,   295,   299,   303,
   307,   311,   315,   319,   323,   327,   331,   335,   339,   343,
   347,   351,   355,   358,   361,   364,   368,   372,   375,   378,
   383,   388,   392,   395,   401,   404,   407,   410,   415,   420,
   425,   428,   436,   442,   443,   444,   448,   450,   451,   453,
   456
};

static const short yyrhs[] = {    92,
     0,    92,    93,     0,     0,    74,   100,    82,     0,   121,
    96,   121,     0,   121,    94,    83,   105,    84,   121,     0,
    95,    75,    36,    85,    97,    35,     0,    79,     0,     0,
    42,    36,    85,    35,   103,     0,    43,    36,    85,    35,
   103,     0,    98,     0,    75,     0,     0,    98,    86,    99,
    36,     0,    99,    36,     0,    74,     0,    76,    74,     0,
    74,     9,     0,    76,    74,     9,     0,    77,     0,   100,
    86,   101,     0,   101,     0,   102,     0,   102,    87,   119,
     0,    36,   121,     0,    36,   121,    88,   119,    89,     0,
     0,    83,   104,   105,    84,     0,   105,   106,     0,     0,
    82,     0,   103,     0,   116,   106,     0,   121,    36,     3,
   106,     0,     1,    82,     0,   107,     0,   108,   121,     0,
    62,    85,   119,    35,   121,   106,     0,    63,   121,   106,
    62,    85,   119,    35,    82,     0,    65,    85,   119,    35,
   121,   106,     0,    66,    85,   119,    35,   121,   106,     0,
    61,    85,   119,    35,   121,   106,     0,    61,    85,   119,
    35,   121,   106,    33,   106,     0,    69,   121,    85,   119,
    35,   121,   103,   113,     0,    71,   121,    85,   119,    35,
   121,   103,   112,     0,    64,    85,   110,    82,   111,    82,
   110,    35,   121,   106,     0,    72,    36,   120,    82,     0,
    73,    83,   122,    84,    82,     0,   120,    41,    82,     0,
    40,   120,    36,    82,     0,   121,    36,    85,   117,    35,
    82,     0,    74,   100,    82,     0,   109,    82,     0,   119,
     0,   119,    38,   119,     0,   119,    39,   119,     0,   119,
    87,   119,     0,   109,     0,     0,   119,     0,     0,   115,
     0,     0,   113,   114,     0,     0,    70,   103,     0,    70,
   121,    85,   119,    35,   103,     0,    70,   103,     0,   120,
    67,   119,     3,     0,   120,    68,     3,     0,   118,     0,
     0,   118,    86,   119,     0,   119,     0,    37,   120,     0,
   119,    19,   119,     0,   119,    18,   119,     0,   119,    20,
   119,     0,   119,    21,   119,     0,   119,     9,   119,     0,
   119,     7,   119,     0,   119,    22,   119,     0,   119,    16,
   119,     0,   119,    17,   119,     0,   119,     8,   119,     0,
   119,    10,   119,     0,   119,    14,   119,     0,   119,    15,
   119,     0,   119,    11,   119,     0,   119,    12,   119,     0,
   119,    13,   119,     0,    80,   120,     0,    81,   120,     0,
    26,   119,     0,   119,     6,   119,     0,   119,     5,   119,
     0,    18,   119,     0,    24,   119,     0,    28,    85,   119,
    35,     0,    29,    85,   119,    35,     0,    85,   119,    35,
     0,   121,    36,     0,   121,    36,    88,   119,    89,     0,
    90,   119,     0,   119,    27,     0,    27,   119,     0,    77,
    85,   119,    35,     0,    30,    85,   119,    35,     0,    31,
    85,   119,    35,     0,   121,    78,     0,    25,    85,   119,
    35,    88,   119,    89,     0,   119,     4,   119,     3,   119,
     0,     0,     0,   122,    86,   123,     0,   123,     0,     0,
   119,     0,     9,   119,     0,     9,   119,     3,   119,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   155,   159,   160,   163,   164,   165,   169,   172,   173,   176,
   177,   180,   181,   182,   185,   186,   189,   190,   191,   192,
   193,   197,   198,   201,   202,   205,   206,   209,   209,   212,
   213,   217,   218,   219,   220,   221,   222,   223,   228,   229,
   230,   231,   232,   233,   234,   235,   236,   237,   241,   242,
   243,   244,   245,   246,   250,   251,   252,   253,   257,   258,
   261,   262,   266,   267,   271,   272,   275,   276,   280,   283,
   284,   287,   288,   291,   292,   295,   296,   297,   298,   299,
   300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
   310,   311,   312,   313,   314,   315,   316,   318,   319,   321,
   322,   324,   325,   326,   327,   329,   330,   332,   333,   334,
   335,   336,   337,   340,   343,   346,   347,   348,   352,   353,
   354
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","':'","'?'",
"OR","AND","'|'","'^'","'&'","REL_EQ","REL_NE","'<'","'>'","REL_LE","REL_GE",
"LEFT","RIGHT","'-'","'+'","'*'","'/'","'%'","UMINUS","'~'","INDIRECT","'!'",
"INCDEC","ABS","SIGN","TYPE","EVENT_SRC","LOWER_THAN_ELSE","ELSE","LOWER_THAN_EXPR_SHIFT",
"')'","ID","NUMBER","ASSIGN","ASSIGN2","TASKOP","JUMP","TASK","SUB","STRING",
"PP_DEFINE","PP_INCLUDE","NL","WS","PP_ARG","PP_UNKNOWN","PP_IFDEF","PP_IF",
"PP_ELSE","PP_ELIF","PP_ENDIF","PP_UNDEF","PP_PRAGMA","PP_GLOM","PP_ERROR","PP_WARNING",
"IF","WHILE","DO","FOR","REPEAT","SWITCH","CASE","DEFAULT","MONITOR","CATCH",
"ACQUIRE","GOTO","ASM","INT","T_VOID","T_CONST","SENSOR","TASKID","NOLIST","CTRUE",
"CFALSE","';'","'{'","'}'","'('","','","'='","'['","']'","'@'","S","unit_list",
"unit","function_head","nolist_opt","fragment","args","arg_list","arg_type",
"var_list","var_item","var_decl","block","@1","stmt_list","stmt","control_stmt",
"misc_stmt","expr_stmt","opt_expr_stmt","opt_expr","opt_handler","handler_list",
"evt_handler","handler","case","params","param_list","expr","saveloc","loc",
"asm_list","asm_item", NULL
};
#endif

static const short yyr1[] = {     0,
    91,    92,    92,    93,    93,    93,    94,    95,    95,    96,
    96,    97,    97,    97,    98,    98,    99,    99,    99,    99,
    99,   100,   100,   101,   101,   102,   102,   104,   103,   105,
   105,   106,   106,   106,   106,   106,   106,   106,   107,   107,
   107,   107,   107,   107,   107,   107,   107,   107,   108,   108,
   108,   108,   108,   108,   109,   109,   109,   109,   110,   110,
   111,   111,   112,   112,   113,   113,   114,   114,   115,   116,
   116,   117,   117,   118,   118,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   119,   119,   119,   119,   119,   119,   119,
   119,   119,   119,   120,   121,   122,   122,   122,   123,   123,
   123
};

static const short yyr2[] = {     0,
     1,     2,     0,     3,     3,     6,     6,     1,     0,     5,
     5,     1,     1,     0,     4,     2,     1,     2,     2,     3,
     1,     3,     1,     1,     3,     2,     5,     0,     4,     2,
     0,     1,     1,     2,     4,     2,     1,     2,     6,     8,
     6,     6,     6,     8,     8,     8,    10,     4,     5,     3,
     4,     6,     3,     2,     1,     3,     3,     3,     1,     0,
     1,     0,     1,     0,     2,     0,     2,     6,     2,     4,
     3,     1,     0,     3,     1,     2,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     2,     2,     2,     3,     3,     2,     2,     4,
     4,     3,     2,     5,     2,     2,     2,     4,     4,     4,
     2,     7,     5,     0,     0,     3,     1,     0,     1,     2,
     4
};

static const short yydefact[] = {     3,
   115,     0,     2,     9,   115,     0,    23,    24,     0,     0,
     8,     0,     0,   115,    26,     4,     0,   115,     0,     0,
    31,     0,     5,   115,    22,   115,   115,     0,   115,   115,
     0,     0,     0,     0,   114,     0,   114,   114,   115,   115,
    25,     0,     0,     0,     0,     0,     0,    98,    99,   115,
    95,   107,   115,   115,   115,   115,    76,   115,    93,    94,
     0,   105,   115,   115,   115,   115,   115,   115,   115,   115,
   115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
   115,   106,   103,   111,     0,     0,     0,   114,     0,     0,
   115,     0,     0,     0,   115,   115,     0,     0,     0,    32,
    28,   115,    33,    30,    37,   115,     0,     0,    55,     0,
     0,    14,    27,     0,     0,     0,     0,     0,     0,   102,
     0,    97,    96,    82,    86,    81,    87,    90,    91,    92,
    88,    89,    84,    85,    78,    77,    79,    80,    83,   115,
    10,    11,    36,     0,   115,   115,     0,   115,   115,   115,
     0,     0,   114,   115,     0,    31,     6,    38,    54,    34,
   115,   115,   115,     0,   115,     0,   103,    17,    13,     0,
    21,     0,    12,     0,     0,   100,   101,   109,   110,   108,
   115,     0,     0,     0,     0,     0,    59,     0,     0,     0,
   115,   115,     0,   115,   119,     0,   117,    53,     0,    56,
    57,    58,    50,     0,    71,     0,   115,    19,    18,     7,
     0,    16,   115,   113,   104,    51,   115,   115,     0,   115,
   115,   115,     0,     0,    48,   120,     0,   115,    29,    70,
    35,     0,    72,    75,    20,     0,     0,     0,     0,   115,
     0,    61,     0,     0,   115,   115,   115,    49,   116,     0,
   115,    15,   112,    43,    39,     0,   115,    41,    42,     0,
     0,   121,    52,    74,     0,     0,     0,    66,    64,    44,
    40,   115,    45,     0,    46,    63,     0,   115,    65,    69,
    47,    67,     0,   115,     0,     0,    68,     0,     0,     0
};

static const short yydefgoto[] = {   288,
     1,     3,    12,    13,    14,   172,   173,   174,     6,     7,
     8,   103,   156,    45,   104,   105,   106,   107,   188,   241,
   275,   273,   279,   276,   108,   232,   233,   109,   110,    42,
   196,   197
};

static const short yypact[] = {-32768,
     9,     5,-32768,     0,-32768,   -29,-32768,   -36,    20,    42,
-32768,     6,    16,-32768,    -7,-32768,     5,   701,     7,    12,
-32768,    49,-32768,   701,-32768,   701,   701,    15,   701,   701,
    17,    18,    21,    23,-32768,    24,-32768,-32768,   701,   701,
  1343,   -26,    63,    76,   433,    35,    10,    94,    94,   701,
    94,    94,   701,   701,   701,   701,-32768,   701,-32768,-32768,
   788,    94,   701,   701,   701,   701,   701,   701,   701,   701,
   701,   701,   701,   701,   701,   701,   701,   701,   701,   701,
   701,-32768,    34,-32768,    50,    50,    52,-32768,    39,    54,
-32768,    58,    60,    62,-32768,-32768,    99,    57,     5,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    66,   571,   331,    46,
   -24,    41,-32768,   820,   852,   884,   916,   948,   980,-32768,
  1269,  1389,  1410,  1430,   535,   386,   411,   411,   137,   137,
   137,   137,    28,    28,    13,    13,    94,    94,    94,   701,
-32768,-32768,-32768,   113,   701,   701,   571,   591,   701,   701,
    65,    67,-32768,   101,    -2,-32768,-32768,-32768,-32768,-32768,
   701,   701,   701,    79,   701,   159,     8,   156,-32768,   100,
-32768,   145,    97,   148,   104,-32768,-32768,-32768,-32768,-32768,
   701,    55,   106,  1012,  1044,   127,-32768,   111,  1076,  1108,
   701,   701,   114,   701,  1343,     2,-32768,-32768,   502,  1343,
  1343,  1343,-32768,  1294,-32768,   571,   659,-32768,   186,-32768,
   -38,-32768,   701,  1367,-32768,-32768,-32768,-32768,   112,   673,
-32768,-32768,  1140,  1172,-32768,  1319,   117,   142,-32768,-32768,
-32768,   165,   115,  1343,-32768,   167,   306,   571,   571,   701,
   122,  1343,   571,   571,-32768,-32768,   701,-32768,-32768,   124,
   701,-32768,-32768,   174,-32768,  1204,   687,-32768,-32768,    50,
    50,  1343,-32768,  1343,   571,   126,   175,-32768,   139,-32768,
-32768,-32768,   141,    50,-32768,-32768,   571,    50,-32768,-32768,
-32768,-32768,   128,   701,  1236,    50,-32768,   212,   214,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,     4,   119,   207,
-32768,   -84,-32768,    69,  -102,-32768,-32768,  -145,   -31,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   228,   -30,    -1,
-32768,     1
};


#define	YYLAST		1457


static const short yytable[] = {     4,
   141,   142,   187,    15,    57,   160,    59,    60,    -1,    83,
   206,   167,    23,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    79,    80,    81,   168,    82,   170,   171,    82,
     5,     9,    10,   111,   186,    77,    78,    79,    80,    81,
    18,    84,    16,    84,    82,    19,    17,   144,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    20,    11,   198,
    24,    82,     2,    17,    46,   227,   164,   228,    21,   147,
    22,    43,   207,   151,   152,   140,    44,    85,   113,    50,
   157,    53,    54,   231,   158,    55,   111,    56,    58,   194,
    86,   187,   165,   166,   168,   169,   170,   171,    26,   112,
    82,   140,   193,   145,    27,    28,    29,    30,    31,    32,
    33,    34,   101,   143,   153,   254,   255,    35,   146,   154,
   258,   259,   148,   215,   149,   111,   150,   159,   183,   191,
   194,   192,    75,    76,    77,    78,    79,    80,    81,    26,
   203,   205,   270,    82,   208,    27,    28,    29,    30,    31,
    32,    33,    34,   209,   281,   268,   269,    36,    35,   210,
    37,    38,   211,   212,  -118,    39,  -118,   216,   219,   280,
    40,   213,   220,   282,   235,   225,   240,   111,   248,   250,
   251,   287,   252,   257,   111,   263,   265,   271,   274,   272,
   278,   289,   284,   290,   236,   238,   239,   155,    36,   243,
   244,    37,    38,    25,   199,   267,    39,     0,   249,     0,
     0,    40,     0,     0,     0,     0,   111,   111,     0,     0,
     0,   111,   111,   260,   261,    41,     0,     0,     0,     0,
     0,    47,     0,    48,    49,     0,    51,    52,     0,     0,
     0,     0,     0,   111,     0,     0,    61,    62,     0,     0,
   277,     0,     0,     0,     0,   111,   283,   114,     0,     0,
   115,   116,   117,   118,     0,   119,     0,     0,     0,     0,
   121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,     0,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,     0,     0,     0,     0,    82,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   182,   161,   162,
     0,     0,   184,   185,     0,     0,   189,   190,     0,     0,
     0,   195,     0,     0,     0,     0,     0,     0,   200,   201,
   202,     0,   204,     0,   253,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,   214,     0,
     0,     0,    82,     0,     0,     0,     0,   163,   223,   224,
     0,   226,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    87,   234,     0,     0,    82,     0,     0,
   237,     0,     0,     0,     0,     0,     0,   242,     0,     0,
    26,     0,     0,     0,     0,   195,    27,    28,    29,    30,
    31,    32,    33,    34,     0,     0,     0,   256,  -115,    35,
     0,     0,    88,  -114,   262,     0,     0,     0,   264,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    89,    90,    91,    92,    93,    94,  -114,
  -114,    95,    87,    96,    97,    98,    99,     0,     0,    36,
  -115,   285,    37,    38,   100,   101,   102,    39,     0,    26,
     0,     0,    40,     0,     0,    27,    28,    29,    30,    31,
    32,    33,    34,     0,     0,     0,     0,  -115,    35,     0,
     0,    88,  -114,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
     0,    82,    89,    90,    91,    92,    93,    94,  -114,  -114,
    95,    87,    96,    97,    98,    99,     0,     0,    36,  -115,
     0,    37,    38,   100,   101,   229,    39,     0,    26,     0,
     0,    40,     0,     0,    27,    28,    29,    30,    31,    32,
    33,    34,     0,     0,     0,     0,  -115,    35,    26,     0,
    88,  -114,     0,     0,    27,    28,    29,    30,    31,    32,
    33,    34,     0,     0,     0,     0,     0,    35,     0,     0,
     0,    89,    90,    91,    92,    93,    94,  -114,  -114,    95,
     0,    96,    97,    98,    99,     0,     0,    36,  -115,     0,
    37,    38,   100,   101,     0,    39,     0,     0,     0,     0,
    40,     0,     0,     0,     0,     0,     0,    36,     0,     0,
    37,    38,   -60,     0,     0,    39,    26,     0,     0,     0,
    40,     0,    27,    28,    29,    30,    31,    32,    33,    34,
    26,     0,     0,   -73,     0,    35,    27,    28,    29,    30,
    31,    32,    33,    34,    26,     0,     0,     0,     0,    35,
    27,    28,    29,    30,    31,    32,    33,    34,    26,     0,
     0,   -60,     0,    35,    27,    28,    29,    30,    31,    32,
    33,    34,     0,     0,     0,    36,     0,    35,    37,    38,
     0,     0,     0,    39,     0,     0,     0,     0,    40,    36,
     0,     0,    37,    38,   -62,     0,     0,    39,     0,     0,
     0,     0,    40,    36,     0,     0,    37,    38,     0,     0,
     0,    39,     0,     0,     0,     0,    40,    36,     0,     0,
    37,    38,     0,     0,     0,    39,     0,     0,     0,     0,
    40,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
     0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
     0,     0,   120,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
     0,     0,     0,     0,   175,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,     0,     0,     0,     0,    82,     0,
     0,     0,     0,     0,     0,     0,   176,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
    82,     0,     0,     0,     0,     0,     0,     0,   177,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
   178,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
     0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
     0,     0,   179,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
     0,     0,     0,     0,   180,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,     0,     0,     0,     0,    82,     0,
     0,     0,     0,     0,     0,     0,   217,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
    82,     0,     0,     0,     0,     0,     0,     0,   218,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
   221,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
     0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
     0,     0,   222,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82,     0,     0,     0,
     0,     0,     0,     0,   245,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,     0,     0,     0,     0,    82,     0,
     0,     0,     0,     0,     0,     0,   246,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
    82,     0,     0,     0,     0,     0,     0,     0,   266,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
     0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
   286,   181,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,   230,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
    82,   247,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,     0,     0,     0,     0,    82,
-32768,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,     0,    82,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,     0,     0,     0,     0,    82,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,     0,     0,     0,     0,    82
};

static const short yycheck[] = {     1,
    85,    86,   148,     5,    35,   108,    37,    38,     0,    36,
     3,    36,    14,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    20,    21,    22,    74,    27,    76,    77,    27,
    36,    42,    43,    45,   147,    18,    19,    20,    21,    22,
    87,    78,    82,    78,    27,    36,    86,    88,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    36,    79,    82,
    88,    27,    74,    86,    36,    84,    41,    86,    83,    91,
    75,    85,    85,    95,    96,    88,    85,    35,    89,    85,
   102,    85,    85,   206,   106,    85,   108,    85,    85,     9,
    35,   257,    67,    68,    74,    75,    76,    77,    18,    85,
    27,    88,   153,    85,    24,    25,    26,    27,    28,    29,
    30,    31,    83,    82,    36,   238,   239,    37,    85,    83,
   243,   244,    85,    89,    85,   147,    85,    82,    36,    85,
     9,    85,    16,    17,    18,    19,    20,    21,    22,    18,
    82,     3,   265,    27,     9,    24,    25,    26,    27,    28,
    29,    30,    31,    74,   277,   260,   261,    77,    37,    35,
    80,    81,    86,    36,    84,    85,    86,    82,    62,   274,
    90,    88,    82,   278,     9,    82,    85,   199,    82,    35,
    86,   286,    36,    82,   206,    82,    33,    82,    70,    35,
    70,     0,    85,     0,   211,   217,   218,    99,    77,   221,
   222,    80,    81,    17,   156,   257,    85,    -1,   228,    -1,
    -1,    90,    -1,    -1,    -1,    -1,   238,   239,    -1,    -1,
    -1,   243,   244,   245,   246,    18,    -1,    -1,    -1,    -1,
    -1,    24,    -1,    26,    27,    -1,    29,    30,    -1,    -1,
    -1,    -1,    -1,   265,    -1,    -1,    39,    40,    -1,    -1,
   272,    -1,    -1,    -1,    -1,   277,   278,    50,    -1,    -1,
    53,    54,    55,    56,    -1,    58,    -1,    -1,    -1,    -1,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,    -1,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,    38,    39,
    -1,    -1,   145,   146,    -1,    -1,   149,   150,    -1,    -1,
    -1,   154,    -1,    -1,    -1,    -1,    -1,    -1,   161,   162,
   163,    -1,   165,    -1,    89,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,   181,    -1,
    -1,    -1,    27,    -1,    -1,    -1,    -1,    87,   191,   192,
    -1,   194,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,     1,   207,    -1,    -1,    27,    -1,    -1,
   213,    -1,    -1,    -1,    -1,    -1,    -1,   220,    -1,    -1,
    18,    -1,    -1,    -1,    -1,   228,    24,    25,    26,    27,
    28,    29,    30,    31,    -1,    -1,    -1,   240,    36,    37,
    -1,    -1,    40,    41,   247,    -1,    -1,    -1,   251,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    61,    62,    63,    64,    65,    66,    67,
    68,    69,     1,    71,    72,    73,    74,    -1,    -1,    77,
    78,   284,    80,    81,    82,    83,    84,    85,    -1,    18,
    -1,    -1,    90,    -1,    -1,    24,    25,    26,    27,    28,
    29,    30,    31,    -1,    -1,    -1,    -1,    36,    37,    -1,
    -1,    40,    41,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,
    -1,    27,    61,    62,    63,    64,    65,    66,    67,    68,
    69,     1,    71,    72,    73,    74,    -1,    -1,    77,    78,
    -1,    80,    81,    82,    83,    84,    85,    -1,    18,    -1,
    -1,    90,    -1,    -1,    24,    25,    26,    27,    28,    29,
    30,    31,    -1,    -1,    -1,    -1,    36,    37,    18,    -1,
    40,    41,    -1,    -1,    24,    25,    26,    27,    28,    29,
    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
    -1,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    -1,    71,    72,    73,    74,    -1,    -1,    77,    78,    -1,
    80,    81,    82,    83,    -1,    85,    -1,    -1,    -1,    -1,
    90,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
    80,    81,    82,    -1,    -1,    85,    18,    -1,    -1,    -1,
    90,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
    18,    -1,    -1,    35,    -1,    37,    24,    25,    26,    27,
    28,    29,    30,    31,    18,    -1,    -1,    -1,    -1,    37,
    24,    25,    26,    27,    28,    29,    30,    31,    18,    -1,
    -1,    35,    -1,    37,    24,    25,    26,    27,    28,    29,
    30,    31,    -1,    -1,    -1,    77,    -1,    37,    80,    81,
    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    90,    77,
    -1,    -1,    80,    81,    82,    -1,    -1,    85,    -1,    -1,
    -1,    -1,    90,    77,    -1,    -1,    80,    81,    -1,    -1,
    -1,    85,    -1,    -1,    -1,    -1,    90,    77,    -1,    -1,
    80,    81,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
    90,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    35,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    35,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    35,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    35,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    35,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    35,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    -1,    -1,
    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    35,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
    27,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    27,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
    -1,    -1,    -1,    27,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    -1,    -1,    -1,    -1,    27,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    27
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 155 "parse.y"
{ yyval.fInt = 0; ;
    break;}
case 4:
#line 163 "parse.y"
{ gProgram->AddGlobalDecls(yyvsp[-1].fBlock); ;
    break;}
case 5:
#line 164 "parse.y"
{ yyvsp[-1].fFragment->SetLocations(yyvsp[-2].fLocation, yyvsp[0].fLocation); ;
    break;}
case 6:
#line 165 "parse.y"
{ EndFunction(yyvsp[-4].fFunction, yyvsp[-2].fBlock, yyvsp[-5].fLocation, yyvsp[0].fLocation); ;
    break;}
case 7:
#line 169 "parse.y"
{ yyval.fFunction = BeginFunction(yyvsp[-1].fFunction, yyvsp[-3].fSymbol, yyvsp[-5].fBool); ;
    break;}
case 8:
#line 172 "parse.y"
{ yyval.fBool = 0; ;
    break;}
case 9:
#line 173 "parse.y"
{ yyval.fBool = 1; ;
    break;}
case 10:
#line 176 "parse.y"
{ yyval.fFragment = new Fragment(kRCX_TaskFragment, yyvsp[-3].fSymbol, yyvsp[0].fStmt); ;
    break;}
case 11:
#line 177 "parse.y"
{ yyval.fFragment = new Fragment(kRCX_SubFragment, yyvsp[-3].fSymbol, yyvsp[0].fStmt); ;
    break;}
case 13:
#line 181 "parse.y"
{ yyval.fFunction = new FunctionDef(); ;
    break;}
case 14:
#line 182 "parse.y"
{ yyval.fFunction = new FunctionDef(); ;
    break;}
case 15:
#line 185 "parse.y"
{ yyval.fFunction = yyvsp[-3].fFunction; 	DefineArg(yyval.fFunction, yyvsp[0].fSymbol, yyvsp[-1].fInt); ;
    break;}
case 16:
#line 186 "parse.y"
{ yyval.fFunction = new FunctionDef(); DefineArg(yyval.fFunction,yyvsp[0].fSymbol,yyvsp[-1].fInt); ;
    break;}
case 17:
#line 189 "parse.y"
{ yyval.fInt = FunctionDef::kIntegerArg; ;
    break;}
case 18:
#line 190 "parse.y"
{ yyval.fInt = FunctionDef::kConstantArg; ;
    break;}
case 19:
#line 191 "parse.y"
{ yyval.fInt = FunctionDef::kReferenceArg; ;
    break;}
case 20:
#line 192 "parse.y"
{ yyval.fInt = FunctionDef::kConstRefArg; ;
    break;}
case 21:
#line 193 "parse.y"
{ yyval.fInt = FunctionDef::kSensorArg; ;
    break;}
case 22:
#line 197 "parse.y"
{ yyvsp[-2].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-2].fBlock; ;
    break;}
case 23:
#line 198 "parse.y"
{ yyval.fBlock = new BlockStmt(); yyval.fBlock->Add(yyvsp[0].fStmt); ;
    break;}
case 24:
#line 201 "parse.y"
{ yyval.fStmt = yyvsp[0].fDeclareStmt; ;
    break;}
case 25:
#line 202 "parse.y"
{ yyval.fStmt = yyvsp[-2].fDeclareStmt; yyvsp[-2].fDeclareStmt->SetInitialValue(yyvsp[0].fExpr); ;
    break;}
case 26:
#line 205 "parse.y"
{ yyval.fDeclareStmt = MakeDeclareStmt(yyvsp[-1].fSymbol, yyvsp[0].fLocation, 0); ;
    break;}
case 27:
#line 206 "parse.y"
{ yyval.fDeclareStmt = MakeDeclareStmt(yyvsp[-4].fSymbol, yyvsp[-3].fLocation, yyvsp[-1].fExpr); ;
    break;}
case 28:
#line 209 "parse.y"
{ BeginScope(); ;
    break;}
case 29:
#line 209 "parse.y"
{ yyval.fStmt = EndScope(yyvsp[-1].fBlock); ;
    break;}
case 30:
#line 212 "parse.y"
{ yyvsp[-1].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-1].fBlock; ;
    break;}
case 31:
#line 213 "parse.y"
{ yyval.fBlock = new BlockStmt(); ;
    break;}
case 32:
#line 217 "parse.y"
{ yyval.fStmt = new BlockStmt(); ;
    break;}
case 34:
#line 219 "parse.y"
{ yyval.fStmt = yyvsp[-1].fCaseStmt; yyvsp[-1].fCaseStmt->SetStmt(yyvsp[0].fStmt); ;
    break;}
case 35:
#line 220 "parse.y"
{ yyval.fStmt = new LabelStmt(yyvsp[-2].fSymbol, yyvsp[-3].fLocation->GetLoc(), yyvsp[0].fStmt); delete yyvsp[-3].fLocation; ;
    break;}
case 36:
#line 221 "parse.y"
{  yyerrok; yyval.fStmt = new BlockStmt(); ;
    break;}
case 38:
#line 223 "parse.y"
{ yyvsp[-1].fStmt->SetLocation(yyvsp[0].fLocation); ;
    break;}
case 39:
#line 228 "parse.y"
{ yyval.fStmt = new WhileStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 40:
#line 229 "parse.y"
{ yyval.fStmt = new DoStmt(yyvsp[-2].fExpr, yyvsp[-5].fStmt); yyval.fStmt->SetLocation(yyvsp[-6].fLocation); ;
    break;}
case 41:
#line 230 "parse.y"
{ yyval.fStmt = new RepeatStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 42:
#line 231 "parse.y"
{ yyval.fStmt = new SwitchStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 43:
#line 232 "parse.y"
{ yyval.fStmt = new IfStmt(yyvsp[-3].fExpr, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 44:
#line 233 "parse.y"
{ yyval.fStmt = new IfStmt(yyvsp[-5].fExpr, yyvsp[-2].fStmt, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-3].fLocation); ;
    break;}
case 45:
#line 234 "parse.y"
{ yyval.fStmt = new MonitorStmt(yyvsp[-4].fExpr, yyvsp[-1].fStmt, yyvsp[0].fBlock, yyvsp[-6].fLocation->GetLoc()); delete yyvsp[-6].fLocation; yyval.fStmt->SetLocation(yyvsp[-2].fLocation); ;
    break;}
case 46:
#line 235 "parse.y"
{ yyval.fStmt = MakeAcquireStmt(yyvsp[-4].fExpr, yyvsp[-1].fStmt, yyvsp[0].fStmt, yyvsp[-6].fLocation); yyval.fStmt->SetLocation(yyvsp[-2].fLocation); ;
    break;}
case 47:
#line 236 "parse.y"
{ yyval.fStmt = new ForStmt(yyvsp[-7].fStmt, yyvsp[-5].fExpr, yyvsp[-3].fStmt, yyvsp[0].fStmt); yyval.fStmt->SetLocation(yyvsp[-1].fLocation); ;
    break;}
case 48:
#line 237 "parse.y"
{ yyval.fStmt = new GotoStmt(yyvsp[-2].fSymbol, sSavedLoc); ;
    break;}
case 49:
#line 241 "parse.y"
{ yyval.fStmt = yyvsp[-2].fAsmStmt; ;
    break;}
case 50:
#line 242 "parse.y"
{ yyval.fStmt = new JumpStmt(yyvsp[-1].fInt, sSavedLoc); ;
    break;}
case 51:
#line 243 "parse.y"
{ yyval.fStmt = new TaskStmt((UByte)yyvsp[-3].fInt, yyvsp[-1].fSymbol, sSavedLoc); ;
    break;}
case 52:
#line 244 "parse.y"
{ yyval.fStmt = yyvsp[-2].fCall; yyvsp[-2].fCall->SetName(yyvsp[-4].fSymbol); yyvsp[-2].fCall->SetLocation(yyvsp[-5].fLocation->GetLoc()); delete yyvsp[-5].fLocation; ;
    break;}
case 53:
#line 245 "parse.y"
{ yyval.fStmt = yyvsp[-1].fBlock; ;
    break;}
case 55:
#line 250 "parse.y"
{ yyval.fStmt = new ExprStmt(yyvsp[0].fExpr); ;
    break;}
case 56:
#line 251 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = new AssignMathStmt(yyvsp[-2].fExpr, (RCX_VarCode)yyvsp[-1].fInt, yyvsp[0].fExpr); ;
    break;}
case 57:
#line 252 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = MakeAssign2Stmt(yyvsp[-2].fExpr, yyvsp[-1].fInt, yyvsp[0].fExpr); ;
    break;}
case 58:
#line 253 "parse.y"
{ CheckLValue(yyvsp[-2].fExpr); yyval.fStmt = new AssignStmt(yyvsp[-2].fExpr, yyvsp[0].fExpr); ;
    break;}
case 60:
#line 258 "parse.y"
{ yyval.fStmt = 0; ;
    break;}
case 62:
#line 262 "parse.y"
{ yyval.fExpr = 0; ;
    break;}
case 64:
#line 267 "parse.y"
{ yyval.fStmt = 0; ;
    break;}
case 65:
#line 271 "parse.y"
{ yyvsp[-1].fBlock->Add(yyvsp[0].fStmt); yyval.fBlock = yyvsp[-1].fBlock; ;
    break;}
case 66:
#line 272 "parse.y"
{ yyval.fBlock =  new BlockStmt(); ;
    break;}
case 67:
#line 275 "parse.y"
{ yyval.fStmt = yyvsp[0].fStmt; ;
    break;}
case 68:
#line 276 "parse.y"
{ yyval.fStmt = MakeCatchStmt(yyvsp[-2].fExpr, yyvsp[0].fStmt, yyvsp[-4].fLocation); ;
    break;}
case 69:
#line 280 "parse.y"
{ yyval.fStmt = yyvsp[0].fStmt; ;
    break;}
case 70:
#line 283 "parse.y"
{ yyval.fCaseStmt = MakeCaseStmt(yyvsp[-1].fExpr, sSavedLoc); ;
    break;}
case 71:
#line 284 "parse.y"
{ yyval.fCaseStmt = new CaseStmt(CaseStmt::kDefaultValue, sSavedLoc); ;
    break;}
case 73:
#line 288 "parse.y"
{ yyval.fCall = new CallStmt(); ;
    break;}
case 74:
#line 291 "parse.y"
{ yyval.fCall = yyvsp[-2].fCall; yyval.fCall->AddParam(yyvsp[0].fExpr); ;
    break;}
case 75:
#line 292 "parse.y"
{ yyval.fCall = new CallStmt(); yyval.fCall->AddParam(yyvsp[0].fExpr); ;
    break;}
case 76:
#line 295 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, yyvsp[-1].fInt, sSavedLoc); ;
    break;}
case 77:
#line 296 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '+', yyvsp[0].fExpr); ;
    break;}
case 78:
#line 297 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '-', yyvsp[0].fExpr); ;
    break;}
case 79:
#line 298 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '*', yyvsp[0].fExpr); ;
    break;}
case 80:
#line 299 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '/', yyvsp[0].fExpr); ;
    break;}
case 81:
#line 300 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '&', yyvsp[0].fExpr); ;
    break;}
case 82:
#line 301 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '|', yyvsp[0].fExpr); ;
    break;}
case 83:
#line 302 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '%', yyvsp[0].fExpr); ;
    break;}
case 84:
#line 303 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, LEFT, yyvsp[0].fExpr); ;
    break;}
case 85:
#line 304 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, RIGHT, yyvsp[0].fExpr); ;
    break;}
case 86:
#line 305 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(yyvsp[-2].fExpr, '^', yyvsp[0].fExpr); ;
    break;}
case 87:
#line 306 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kEqualTo, yyvsp[0].fExpr); ;
    break;}
case 88:
#line 307 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kLessOrEqual, yyvsp[0].fExpr); ;
    break;}
case 89:
#line 308 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kGreaterOrEqual, yyvsp[0].fExpr); ;
    break;}
case 90:
#line 309 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kNotEqualTo, yyvsp[0].fExpr); ;
    break;}
case 91:
#line 310 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kLessThan, yyvsp[0].fExpr); ;
    break;}
case 92:
#line 311 "parse.y"
{ yyval.fExpr = new RelExpr(yyvsp[-2].fExpr, RelExpr::kGreaterThan, yyvsp[0].fExpr); ;
    break;}
case 93:
#line 312 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, 1, sSavedLoc); ;
    break;}
case 94:
#line 313 "parse.y"
{ yyval.fExpr = new AtomExpr(kRCX_ConstantType, 0, sSavedLoc); ;
    break;}
case 95:
#line 314 "parse.y"
{ yyval.fExpr = new NegateExpr(yyvsp[0].fExpr); ;
    break;}
case 96:
#line 315 "parse.y"
{ yyval.fExpr = new LogicalExpr(yyvsp[-2].fExpr, LogicalExpr::kLogicalAnd, yyvsp[0].fExpr); ;
    break;}
case 97:
#line 316 "parse.y"
{ yyval.fExpr = new LogicalExpr(yyvsp[-2].fExpr, LogicalExpr::kLogicalOr, yyvsp[0].fExpr); ;
    break;}
case 98:
#line 318 "parse.y"
{ yyval.fExpr = MakeBinaryExpr(new AtomExpr(kRCX_ConstantType, 0, yyvsp[0].fExpr->GetLoc()), '-', yyvsp[0].fExpr); ;
    break;}
case 99:
#line 319 "parse.y"
{ yyval.fExpr = MakeUnaryExpr('~', yyvsp[0].fExpr); ;
    break;}
case 100:
#line 321 "parse.y"
{ yyval.fExpr = MakeUnaryExpr(ABS, yyvsp[-1].fExpr); ;
    break;}
case 101:
#line 322 "parse.y"
{ yyval.fExpr = MakeUnaryExpr(SIGN, yyvsp[-1].fExpr); ;
    break;}
case 102:
#line 324 "parse.y"
{ yyval.fExpr = yyvsp[-1].fExpr; ;
    break;}
case 103:
#line 325 "parse.y"
{ yyval.fExpr = MakeVarExpr(yyvsp[0].fSymbol, yyvsp[-1].fLocation); ;
    break;}
case 104:
#line 326 "parse.y"
{ yyval.fExpr = MakeArrayExpr(yyvsp[-3].fSymbol, yyvsp[-4].fLocation, yyvsp[-1].fExpr); ;
    break;}
case 105:
#line 327 "parse.y"
{ yyval.fExpr = MakeValueExpr(yyvsp[0].fExpr); ;
    break;}
case 106:
#line 329 "parse.y"
{ yyval.fExpr = new IncDecExpr(GetLValue(yyvsp[-1].fExpr), yyvsp[0].fInt, false, yyvsp[-1].fExpr->GetLoc()); ;
    break;}
case 107:
#line 330 "parse.y"
{ yyval.fExpr = new IncDecExpr(GetLValue(yyvsp[0].fExpr), yyvsp[-1].fInt, true, yyvsp[0].fExpr->GetLoc()); ;
    break;}
case 108:
#line 332 "parse.y"
{ yyval.fExpr = new SensorExpr(yyvsp[-1].fExpr); ;
    break;}
case 109:
#line 333 "parse.y"
{ yyval.fExpr = new TypeExpr(yyvsp[-1].fExpr); ;
    break;}
case 110:
#line 334 "parse.y"
{ yyval.fExpr = new EventSrcExpr(yyvsp[-1].fExpr, gProgram->GetTarget()->fType); ;
    break;}
case 111:
#line 335 "parse.y"
{ yyval.fExpr = MakeTaskIdExpr(yyvsp[-1].fLocation); ;
    break;}
case 112:
#line 336 "parse.y"
{ yyval.fExpr = MakeIndirectExpr(yyvsp[-4].fExpr, yyvsp[-1].fExpr); ;
    break;}
case 113:
#line 337 "parse.y"
{ yyval.fExpr = new TernaryExpr(yyvsp[-4].fExpr, yyvsp[-2].fExpr, yyvsp[0].fExpr); ;
    break;}
case 114:
#line 340 "parse.y"
{ LexCurrentLocation(sSavedLoc); ;
    break;}
case 115:
#line 343 "parse.y"
{ yyval.fLocation = new LocationNode(); ;
    break;}
case 116:
#line 346 "parse.y"
{ yyval.fAsmStmt = yyvsp[-2].fAsmStmt; yyvsp[-2].fAsmStmt->Add(yyvsp[0].fField); ;
    break;}
case 117:
#line 347 "parse.y"
{ yyval.fAsmStmt = new AsmStmt(); yyval.fAsmStmt->Add(yyvsp[0].fField); ;
    break;}
case 118:
#line 348 "parse.y"
{ yyval.fAsmStmt = new AsmStmt(); ;
    break;}
case 119:
#line 352 "parse.y"
{ yyval.fField = MakeConstField(yyvsp[0].fExpr); ;
    break;}
case 120:
#line 353 "parse.y"
{ yyval.fField = new EAField(yyvsp[0].fExpr); ;
    break;}
case 121:
#line 354 "parse.y"
{ yyval.fField = new EAField(yyvsp[-2].fExpr, GetConstantValue(yyvsp[0].fExpr)); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 357 "parse.y"



void yyerror(const char *msg)
{
	Error(kErr_Parser, msg).RaiseLex();
}


